/* -*-C-*-
********************************************************************************
*
* File:         bmutil.c
*
* Basic mailer utility functions
*
********************************************************************************
*/
/* bmutil.c */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "globals.h"

#define  SETVBUF
#if defined(UNIX) || defined(MICROSOFT)
#include <types.h>
#endif
#if defined(UNIX) || defined(MICROSOFT) || defined(__TURBOC__)
#include <stat.h>
#endif
#ifdef AZTEC
#include <stat.h>
#endif
#include <fcntl.h>
#include "bm.h"
#include "header.h"

char *getname();
static unsigned long mboxsize;
static int anyread;
char aa6ed[] = "http://server.aa6ed.ampr.org/";

#ifdef SETVBUF
#define  MYBUF 4096
char *inbuf = NULLCHAR; /* the stdio buffer for the mail file */
char *outbuf = NULLCHAR; /* the stdio file io buffer for the temp file */
#endif

int
initnotes(int new_s)
{
	FILE *tmpfile();
	FILE *ifile;
	register struct let *cmsg;
	int  i, ret;
	struct stat mstat;

	if (!stat(mfilename,&mstat))
		mboxsize = mstat.st_size;
	if ((ifile = fopen(mfilename,"r")) == NULLFILE) {
		xprintf(new_s,nomail);
		mfile = NULLFILE;
		return 0;
	} 
#ifdef SETVBUF
	if (inbuf == NULLCHAR)
		inbuf = malloc(MYBUF);
	setvbuf(ifile, inbuf, _IOFBF, MYBUF);
#endif
	if ((mfile = tmpfile()) == NULLFILE)
	{
		xprintf(new_s,"Unable to create tmp file\r\n");
		(void) fclose(ifile);
		return -1;
	}
#ifdef SETVBUF
	if (outbuf == NULLCHAR)
		outbuf = malloc(MYBUF);
	setvbuf(mfile, outbuf, _IOFBF, MYBUF);
#endif
	nmsgs = 0;
	current = 0;
	change = 0;
	newmsgs = 0;
	anyread = 0;
	ret = readnotes(new_s,ifile);
	(void) fclose(ifile);
	if (ret != 0)
		return -1;
#ifdef SETVBUF
	if (inbuf != NULLCHAR) {
		(void) free(inbuf);
		inbuf = NULLCHAR;
	}
#endif
	for (cmsg = &mbox[1],i = 1; i <= nmsgs; i++, cmsg++)  
		if ((cmsg->status & READ) == 0) {
			newmsgs++;
			if (current == 0)
				current = i;
		}
	/* start at one if no new messages */
	if (current == 0)
		current++;

	return 0;

}

/* readnotes assumes that ifile is pointing to the first
	* message that needs to be read.  For initial reads of a
	* notesfile, this will be the beginning of the file.  For
	* rereads when new mail arrives, it will be the first new
	* message.
	*/
readnotes(new_s,ifile)
int new_s;
FILE *ifile ;
{
	char  tstring[LINELEN];
	long cpos;
	register struct let *cmsg;
	register char *line;
	long ftell();
	char * temp;

	 /* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

	cmsg = (struct let *)NULL;
	line = tstring;
	while(!feof(ifile)) {
		fgets(line,LINELEN,ifile);
		/* scan for begining of a message */
		if(strncmp(line,"From ",5) == 0) {
			cpos = ftell(mfile);
			fputs(line,mfile);
			if (nmsgs == maxlet) {
				sprintf(temp,"Mail box full: > %d messages\r\n",maxlet);
				xprintf(new_s,temp);
				(void) fclose(mfile);
				free(temp);
				return -1;
			}
			nmsgs++;
			cmsg = &mbox[nmsgs];
			cmsg->start = cpos;
			cmsg->status = 0;
			cmsg->size = strlen(line);
			while (!feof(ifile)) {
				if (fgets(line,LINELEN,ifile) == NULLCHAR)
					break;
				if (*line == '\n') { /* done header part */
					cmsg->size++;
					putc(*line, mfile);
					break;
				}
				if (htype(line) == STATUS) {
					if (line[8] == 'R') 
						cmsg->status |= READ;
					continue;
				}
				cmsg->size += strlen(line);
				if (fputs(line,mfile) == EOF) {
					perror("tmp file");
					(void) fclose(mfile);
					free(temp);
					return -1;
				}

			}
		} else if (cmsg) {
			cmsg->size += strlen(line);
			fputs(line,mfile);
		}
	}
	free(temp);
	return 0;
}

/* list headers of a notesfile a message */
listnotes(int new_s)
{
	register struct let *cmsg;
	register char *p, *s;
	char smtp_date[SLINELEN];
	char smtp_from[SLINELEN];
	char smtp_subject[SLINELEN];
	char tstring[LINELEN];
	int i,c;
	int lines;
	long size;
	char * temp;

	/* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

	if (mfile == NULLFILE)
		return;

	xprint_header(new_s,"Receive Queue");
	xprintf(new_s,"\n<PRE>");
	sprintf(temp,"Mailbox %s - %d messages %d new\r\n<UL>\n",mfilename,nmsgs,newmsgs);
	xprintf(new_s,temp);
	lines = 2;
	for (cmsg = &mbox[1],i = 1; i <= nmsgs; i++, cmsg++) {
		*smtp_date = '\0';
		*smtp_from = '\0';
		*smtp_subject = '\0';
		fseek(mfile,cmsg->start,0);
		size = cmsg->size;
		while (!feof(mfile) && size > 0) {
			fgets(tstring,sizeof(tstring),mfile);
			if (*tstring == '\n') /* end of header */
				break;
			size -= strlen(tstring);
			rip(tstring);
			/* handle continuation later */
			if (*tstring == ' '|| *tstring == '\t')
				continue;
			switch(htype(tstring)) {
			case FROM:
				if((p = getname(tstring)) == NULLCHAR) {
					p = &tstring[6];
					while(*p && *p != ' ' && *p != '(')
						p++;
					*p = '\0';
					p = &tstring[6];
				}
				sprintf(smtp_from,"%.30s",p);
				break;
			case SUBJECT:
				sprintf(smtp_subject,"%.50s",&tstring[9]);
				break;
			case DATE:
				if ((p = strchr(tstring,',')) == NULLCHAR)
					p = &tstring[6];
				else
					p++;
				/* skip spaces */
				while (*p == ' ') p++;
				if(strlen(p) < 17)
					break;  /* not a valid length */
				s = smtp_date;
				/* copy day */
				if (atoi(p) < 10 && *p != '0') {
					*s++ = ' ';
				} else
					*s++ = *p++;
				*s++ = *p++;

				*s++ = ' ';
				while (*p == ' ')
					p++;
				/* copy month */
				*s++ = *p++;
				*s++ = *p++;
				*s++ = *p++;
				while (*p == ' ')
					p++;
				/* skip year */
				while (isdigit(*p))
					p++;
				/* copy time */
				*s++ = *p++; /* space */
				*s++ = *p++; /* hour */
				*s++ = *p++;
				*s++ = *p++; /* : */
				*s++ = *p++; /* min */
				*s++ = *p++;
				*s = '\0';
				break;
			case NOHEADER:
				break;
			}
		}
		sprintf(temp,
		"<LI><A HREF=\"%sr+%s+%d\">%c%c%c%3d %-27.27s %-12.12s %5ld %s</A></LI>\n",
						aa6ed,  notename,i,
						(i == current ? '>' : ' '),
						(cmsg->status & DELETE ? 'D' : ' '),
						(cmsg->status & READ ? 'Y' : 'N'),
						i, smtp_from, smtp_date,
						cmsg->size, smtp_subject);
		xprintf(new_s,temp);
		}
	xprintf(new_s,"\n</UL></PRE>\n");
	xprint_footer(new_s);
	closesocket(new_s);
	free(temp);
}


/* get a message id from the sequence file */
long
get_msgid()
{
	char sfilename[SLINELEN];
	char s[20];
	long sequence = 0L;
	FILE *sfile;
	long atol();

	sprintf(sfilename,"%s/sequence.seq", mqueue);
	sfile = fopen(sfilename,"r");

	/* if sequence file exists, get the value, otherwise set it */
	if (sfile != NULLFILE) {
		fgets(s,sizeof(s),sfile);
		sequence = atol(s);
	/* Keep it in range of and 8 digit number to use for dos name prefix. */
		if (sequence < 0L || sequence > 99999999L )
			sequence = 0L;
		(void) fclose(sfile);
	}

	/* increment sequence number, and write to sequence file */
	sfile = fopen(sfilename,"w");
	fprintf(sfile,"%ld",++sequence);
	(void) fclose(sfile);
	return sequence;
}

/* Given a string of the form <user@host>, extract the part inside the
	* brackets and return a pointer to it.
	*/
char *
getname(cp)
register char *cp;
{
	char *cp1;

	if((cp = strchr(cp,'<')) == NULLCHAR)
		return NULLCHAR;
	cp++; /* cp -> first char of name */
	if((cp1 = strchr(cp,'>')) == NULLCHAR)
		return NULLCHAR;
	*cp1 = '\0';
	return cp;
}

/* create mail lockfile */
int
mlock(dir,id)
char *dir;
char *id;
{
	char lockname[SLINELEN];
	int fd;
	/* Try to create the lock file in an atomic operation */
	sprintf(lockname,"%s/%.8s.lck",dir,id);
	if((fd = open(lockname, O_WRONLY|O_EXCL|O_CREAT,0600)) == -1)
		return -1;
	(void) close(fd);
	return 0;
}

/* remove mail lockfile */
int
rmlock(dir,id)
char *dir;
char *id;
{
	char lockname[SLINELEN];
	sprintf(lockname,"%s/%.8s.lck",dir,id);
	(void) unlink(lockname);
}

/* parse a line into argv array. Return argc */
int
parse(line,argv,maxargs)
register char *line;
char *argv[];
int maxargs;
{
	int argc;
	int qflag;
	int i;
	register char *cp;

	for(argc = 0; argc < maxargs; argc++)
		argv[argc] = NULLCHAR;

	for (i=0; i< strlen(line); i++)
	{
	 if (line[i] == '+') line[i] = ' ';
	 if (line[i] == '?') line[i] = ' ';
	}

	for(argc = 0; argc < maxargs;){
		qflag = 0;
		/* Skip leading white space  and question separater*/
		while(*line == ' ' || *line == '\t')
			line++;
		if(*line == '\0')
			break;
		/* Check for quoted token */
		if(*line == '"'){
			line++; /* Suppress quote */
			qflag = 1;
		}
		argv[argc++] = line; /* Beginning of token */
		/* Find terminating delimiter */
		if(qflag){
			/* Find quote, it must be present */
			if((line = strchr(line,'"')) == NULLCHAR){
				return -1;
			}
			*line++ = '\0';
		} else {
			/* Find space or tab. If not present,
				* then we've already found the last
				* token.
				*/
			if( (cp = strchr(line,' ') ) == NULLCHAR
				 && (cp = strchr(line,'\t')) == NULLCHAR
				  )
				 {
				break;
			}
			*cp++ = '\0';
			line = cp;
		}
	}
	return argc;
}

lockit(int new_s)
{
	char line[SLINELEN];
	while(mlock(maildir,notename)) {
		xprintf(new_s,"Mail file is busy, Abort or Retry ? ");
		xgets(new_s,line);
		if (*line == 'A' || *line == 'a') {
			if ( mfile != NULLFILE)
				(void) fclose(mfile);
			mfile = NULLFILE;
			return 1;
		}
	}
	return 0;
}


/*  display message on the crt given msg number */
displaymsg(new_s,msg)
int new_s;
int msg;
{
	register int c;
	register int col;
	char buf[MAXCOL+2];  /* line buffer */
	int lines;
	int cnt;
	long  tsize, size;
	char * temp;

	if (mfile == NULLFILE) {
		xprintf(new_s,nomail);
		return;
	}
	if( msg < 0 || msg > nmsgs) {
		sprintf(temp, badmsg,msg);
		xprintf(new_s,temp);
		return;
	}

	/* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

	fseek(mfile,mbox[msg].start,0);
	size = mbox[msg].size;
	tsize = size;

	sprintf(temp,"Message #%d %s\n",
		msg, mbox[msg].status & DELETE ? "[Deleted]" : "");
	xprint_header(new_s,temp);
	xprintf(new_s,"<PRE>");
	if ((mbox[msg].status & READ) == 0) {
		mbox[msg].status |= READ;
		change = 1;
	}
	lines = 1;
	col = 0;
	while (!feof(mfile) && size > 0) {
		for (col = 0;  col < MAXCOL-2;) {
			c = getc(mfile);
			size--;
			if (feof(mfile) || size == 0) /* end this line */
				break;
			if (c == '\t') {
				cnt = col + 8 - (col & 7);
				if (cnt >= MAXCOL) /* end this line */
					break;
				while (col < cnt)
					buf[col++] = ' ';
			} else if (c == '\n')
				break;
			else
				buf[col++] = c;
		}
		buf[col++] = '\r';
		buf[col++] = '\n';
		buf[col] = '\0';
		xprintf(new_s,buf);

		col = 0;
	}
	xprintf(new_s,"</PRE>");
	xprint_footer(new_s);
	free(temp);
}

/* list jobs wating to be sent in the mqueue */
listqueue(int new_s)
{
	char tstring[80];
	char workfile[80];
	char line[20];
	char host[SLINELEN];
	char to[SLINELEN];
	char from[SLINELEN];
	char *p;
	char status;
	struct stat stbuf;
	struct tm *tminfo, *localtime();
	FILE *fp;
	char * temp;

	/* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

	xprint_header(new_s,"List Messages in Send Queue");
	xprintf(new_s,"<PRE>");
	sprintf(temp,"S     Job    Size Date  Time  Host                 From                To\r\n");
	xprintf(new_s,"<UL>");
	xprintf(new_s,temp);
	sprintf(workfile,"%s/%s",mqueue,WORK);
	filedir(workfile,0,line);
	while(line[0] != '\0') {
		sprintf(tstring,"%s/%s",mqueue,line);
		if ((fp = fopen(tstring,"r")) == NULLFILE) {
			perror(tstring);
			continue;
		}
		if ((p = strrchr(line,'.')) != NULLCHAR)
			*p = '\0';
		sprintf(tstring,"%s/%s.lck",mqueue,line);
		if (access(tstring,0))
			status = ' ';
		else
			status = 'L';
		sprintf(tstring,"%s/%s.txt",mqueue,line);
		stat(tstring,&stbuf);
		tminfo = localtime(&stbuf.st_ctime);
		fgets(host,sizeof(host),fp);
		rip(host);
		fgets(from,sizeof(from),fp);
		rip(from);
		sprintf(temp,"<LI>%c %7s %7ld %02d/%02d %02d:%02d %-20s %s ",
			status, line, stbuf.st_size,
			tminfo ->tm_mon+1,
			tminfo->tm_mday,
			tminfo->tm_hour,
			tminfo->tm_min,
			host,from);
		xprintf(new_s,temp);
		while (fgets(to,sizeof(to),fp) != NULLCHAR) {
			rip(to);
			sprintf(temp,"%s </LI>",to);
			xprintf(new_s,temp);
		}
		(void) fclose(fp);
		filedir(workfile,1,line);
	}
	xprintf(new_s,"</UL></PRE>");
	xprint_footer(new_s);
	free(temp);
}

