/***************************************************************************
 *	Simple Web user interface for Microsoft Windows Winsock IP/TCP package.
 *	Permission granted for non-commercial copying and use, provided
 *	this notice is retained.
 *	Permission granted for non-commercial copying and use, provided
 *	this notice is retained.
 *
 * revision history:
 * Modified by AA6ED to be an HTML WEB Server with SMTP mail support 4/3/96
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <ctype.h>
#include <string.h>
#include "bm.h"
#include "files.c"
#include "globals.h"
#include <winsock.h>
#include <sys\stat.h>

#define MTU_MAX 150


extern char version[];
static char copyright1[] = 
"SMTP mail reader written by Bdale Gargee and Dave Trulli...";
static char copyright2[] =
"WEB Server, Winsock and SMTP reader by William Bytheway AA6ED...";

/* comands valid in bm.rc */


struct token rccmds[] = {
	"smtp", SMTP,
	"host", HOST,
	"user", USER,
	"edit", EDIT,
	"fullname", NAME,
	"reply", REPLY,
	"maxlet", MAXLET,
	"mbox", MBOX,
	"record", RECORD,
	"screen", SCREEN,
	"folder", FOLDER,
	"mqueue", MQUEUE,
	NULLCHAR, 0
};


static char *Hdrs[] = {
		"Content-Type:",
		"Content-Length:"
};

static char *CTypes1[] = {
		"video/",
		"text/",
		"image/",
		"audio/",
		"application/"
};

static char *CTypes2[] = {
		"x-msvideo",
		"quicktime",
		"quicktime",
		"mpeg",
		"mpeg",
		"richtext",
		"html",
		"x-xpixmap",
		"x-xbitmap",
		"x-rgb",
		"x-portable-pixmap",
		"x-portable-graymap",
		"x-portable-bitmap",
		"x-portable-anymap",
		"x-cmu-raster",
		"tiff",
		"jpeg",
		"jpeg",
		"gif",
		"x-wav",
		"x-aiff",
		"basic",
		"basic",
		"x-tar",
		"x-trof-man",
		"rtf",
		"postscript",
		"postscript",
		"x-stuffit",
		"mac-binhex40",
		"fractals",
		"x-zip",
		"x-gzip",
		"x-compress",
		"octet-stream",
		"plain"
};

static char *Ext[] = {
		"avi",
		"qt",
		"mov",
		"mpeg",
		"mpg",
		"rtx",
		"html",
		"xpm",
		"xbm",
		"rgb",
		"ppm",
		"pgm",
		"pbm",
		"pnm",
		"ras",
		"tiff",
		"jpeg",
		"jpg",
		"gif",
		"wav",
		"aiff",
		"au",
		"snd",
		"tar",
		"man",
		"rtf",
		"eps",
		"ps",
		"sit",
		"hqx",
		"fif",
		"zip",
		"gz",
		"z",
		NULLCHAR
};


FILE	*mfile = NULLFILE;
char 	*hostname = NULLCHAR;		/* name of this host from rc file */
char	*username = NULLCHAR;		/* name of this user from rc file */
char	*fullname = NULLCHAR;		/* fullname of this user from rc file */
char	*replyto = NULLCHAR;		/* address for reply-to header */
char	*maildir = NULLCHAR;		/* defined mail directory */
char	*mqueue = NULLCHAR;		/* defined mqueue outbound directory */
char	*savebox = NULLCHAR;		/* name of the mbox text file */
char	*record = NULLCHAR;		/* record  outbound mail in this file */
char	*folder = NULLCHAR;		/* directory for saveing read mail */
char	*editor = NULLCHAR;		/* user's favorite text editor */
char	notename[9];			/* name of current notesfile */
char	notefile[SLINELEN];		/* full pathname of mail text file */
char	*mfilename = notefile;	/* pointer to current mbox or mail file -f */
int	current;			/* the current message number */
int	nmsgs;			/* the number of messages in the notesfile */
int	newmsgs;		/* Number of new unread message */
int	change;			/* indicates that the mail file has been
				 * changed in this session */
int	fflag = 0;		/* true if current notesfile is not an mbox */
int	qflag = 0;		/* true if bm is used just to queue files */
unsigned maxlet = NLET+1;	/* max number of messages in mailbox */
int	tty = 0;		/* tells if stdin is a tty */
struct let *mbox;		/* pointer to the array of messages */


char usage[] = "Usage: bm [-u user] [-f file] \r\n  or bm [-s subject] [-q] addr .. addr\r\n";
char badmsg[] = "Invalid Message number %d\r\n";
char nomail[] = "No messages\r\n";
char noaccess[] = "Unable to access %s\r\n";
int MAIL_READWRITE = 0;

void myexit(void)
{
 WSACleanup();
 printf("Exit called...\n");
}


int isbinary(FILE * fp)

{
    int c,i;
    int rval;
  
    rval = 0;
    for(i=0;i<512;i++){
        if((c = getc(fp)) == EOF)
            break;
        if(c & 0x80){
            /* High bit is set, probably not text */
            rval = 1;
            break;
        }
    }
    /* Assume it was at beginning */
    fseek(fp,0L,SEEK_SET);
    return rval;
}



void badopen(int new_s,char * badname)

{

 char * temp;


 	 /* allocate memory for string */

	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

 	  sprintf(temp,

	  "HTTP/1.0 404\n\n<TITLE>Error</TITLE><H1>404 Not Found</H1>The file \"/%s\" does not exist on this server.\n",badname);
	  xprintf(new_s,temp);

	  free(temp);

}


void send_file(int new_s,char *infile, int with_header)

{

int status = 0;

int i,Ctype1;

char buffer[MTU_MAX];

struct stat buf;

int blen;

int rlen;

char * cp;

FILE *s_in;

char * temp;


	 /* allocate memory for string */

	 if ((temp = (char *) malloc(MTU_MAX)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }



	if ((s_in = fopen(infile, "rb"))

		 == NULL)
	{
		fprintf(stderr, "Cannot open %s.\n",infile);
		badopen(new_s,infile);
		free(temp);
		return;
	}
	if((cp = strrchr(infile,'.')) != NULL)
	{
		cp++;
		for(i=0;Ext[i] != NULL;i++)
		{
		  if(strlen(cp) < 3)
		  {
			 if(!stricmp(Ext[i],cp))
			 break;
		  }
		  else if(!strnicmp(Ext[i],cp,strlen(cp)))
			break;
		}
		if(i < 5)
		  Ctype1 = 0;
		else if(i < 7)
		  Ctype1 = 1;
		else if(i < 19)
		  Ctype1 = 2;
		else if(i < 23)
		  Ctype1 = 3;
		else if(i < 34)
		  Ctype1 = 4;
	else if(isbinary(s_in))
		  Ctype1 = 4;
		else
		{
		  Ctype1 = 1;
		  i = 35;
		}
	}
  else if(isbinary(s_in))
	{
		Ctype1 = 4;
		i = 34;
	}
	else {
		Ctype1 = 1;
		i = 35;
	}

	fstat(fileno(s_in),&buf);

		/* Puts the HTML File Information Header prior to the file send */
	if (with_header)
	{
	  sprintf(temp,"HTTP/1.0 200\n%s %s%s\n%s %ld\n\n",
	  Hdrs[0],CTypes1[Ctype1],CTypes2[i],Hdrs[1],buf.st_size);
		xprintf(new_s,temp);
	  printf("\t[%s]\n\t[%s %s%s]\n\t[%s %ld]\n",infile,

		 Hdrs[0],CTypes1[Ctype1],CTypes2[i],Hdrs[1],buf.st_size);

	}


	while (!feof(s_in))

	 {

		rlen = fread(buffer,1,MTU_MAX,s_in);

		if (rlen > 0)

		  {

		 status = Server_Send(new_s,buffer,rlen);

		  if (status == -1)

		  {

			 fclose(s_in);

			 return;

		  }

		}

	 }

  	fclose(s_in);

}



void xprint_header(int new_s,char * header_string)

{

 char * temp;

	 /* allocate memory for string */

	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }


  send_file(new_s,"l:\\gopher\\header.htm",FALSE);
  sprintf(temp,"<H3>%s</H3>",header_string);

  xprintf(new_s,temp);

  free(temp);

}


void xprint_footer(int new_s)

{

	send_file(new_s,"l:\\gopher\\footer.htm",FALSE);
}



main(argc,argv)
int argc;
char *argv[];
{
	extern int optind;
	extern char *optarg;
	char *subjectline = NULLCHAR;
	long	tmp;
	int	c;
	int	ret;
	char * temp;
	short portnumber = 80;

/*   AA6ED  *******************************************
#if	defined(__TURBOC__) || defined(MICROSOFT)
	(void) fclose(stdaux);
	(void) fclose(stdprn);
#endif
*/

		 /* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

	loadconfig();
	atexit(myexit);  /* aa6ed says a WSACleanup is OK here */

	if (qflag == 0 && isatty(fileno(stdin))) {
		/* announce ourselves */
		printf(" %s\r\n%s\r\n%s\r\n\r\n",version,copyright1,copyright2);
		tty = 1;
	} 

	current = 1;
	nmsgs = 0;

	/* check for important directories */
	if(access(maildir,0)){
		printf(noaccess,maildir);
		exit(1);
	}
	if(access(mqueue,0)){
		printf(noaccess,mqueue);
		exit(1);
	}
	strncpy(notename,username,8);
	notename[8] = '\0';

	while ((c = getopt(argc,argv,"u:f:s:q")) != -1) {
		switch(c) {
		case 'f':
			fflag++;
			mfilename = optarg;
			break;
		case 'q':
			qflag++;
			break;
		case 's':
			subjectline = optarg;
			break;
		case 'u':
			strncpy(notename,optarg,8);
			notename[8] = '\0';
			break;
		case '?':
			printf(usage);
			exit(1);
		}
	}



	tmp = (long)maxlet * (long)sizeof(struct let);
#ifdef	MSDOS
	/*
	* Since we are in the dos small model make sure that we
	* don't overflow a unsigned short on the number bytes
	* need for mallloc. If not checked malloc will
	* succeed and we will be trashing ourself in no time.
	*/
	if ((tmp & 0xffff0000) ||
	    (mbox=(struct let *)malloc((unsigned short)tmp)) == (struct let *)NULL){
#else
	if ((mbox=(struct let *)malloc((unsigned)tmp)) == (struct let *)NULL){
#endif
		fprintf(stderr,
		"Can't allocate memory table for %d messages\r\n",
			 maxlet);
		(void) exit(1);
	}

	printf("Port number 80 used for connects.\n");
	Server_Process(portnumber); /* does command processing */
	return 0;
}

loadconfig(int new_s)
{
	FILE	*rcfp;	/* handle for the configuration file */
	char	rcline[LINELEN]; /* buffer for config file reading */
	register char *s,*p;
	int line = 0;
	char runcom[LINELEN];
	char *getenv();
	char temp[256];

#ifdef UNIX
	/* Try $HOME/RUNCOM */
	if ((p = getenv("HOME")) != NULLCHAR)
		sprintf(runcom, "%s/%s", p, RUNCOM);
#else
	/* check for BMRC in the ENV */
	if ((p = getenv("BMRC")) != NULLCHAR)
		strcpy(runcom,p);
#endif
	else
		strcpy(runcom,RUNCOM);

	if ((rcfp = fopen(runcom,"r")) == NULLFILE) {	/* open config file */
		sprintf(temp,"Cannot open '%s', check your installation\r\n",runcom);
		printf(temp);
		(void) exit(1);
	}
	while (!feof(rcfp)) {
		if (fgets(rcline,LINELEN,rcfp) == NULLCHAR)
			break;
		line++;
		rip(rcline);
		if (*rcline == '\0' || *rcline == ';'|| *rcline == '#')
			continue;
		/* find the argument to the command */

		s = rcline;
		/* skip the white space */
		while(*s == ' ' || *s == '\t')
				s++;
		p = s;
		/* skip the command */
		while(*p && *p != ' ' && *p != '\t')
				p++;
		/* skip the white space */
		while(*p == ' ' || *p == '\t')
				p++;
		if (*s == '\0')
			continue;

		switch (rc_line_type(s)) {
		case HOST:
			hostname = savestr(p);
			break;
		case USER:
			username = savestr(p);
			break;
		case REPLY:
			replyto = savestr(p);
			break;
		case EDIT:
			editor = savestr(p);
			break;
		case SMTP:
			maildir = savestr(p);
			break;
		case NAME:
			fullname = savestr(p);
			break;
		case MAXLET:
			maxlet = atoi(p)+1;
			break;
		case MBOX:
			savebox = savestr(p);
			break;
		case RECORD:
			record = savestr(p);
			break;
		case SCREEN:
#if	defined(__TURBOC__)
			setvideo(p);
#endif
			break;
		case FOLDER:
			folder = savestr(p);
			break;
		case MQUEUE:
			mqueue = savestr(p);
			break;
		default:
			fprintf(stderr,
			"%s: line %d Invalid command: '%s'\r\n",
			runcom,line,rcline);
			exit(1);
		}
	}
	(void) fclose(rcfp);
	if(maildir == NULLCHAR)
		maildir = mailspool;
	if(mqueue == NULLCHAR)
		mqueue = mailqdir;
	if(savebox == NULLCHAR)
		savebox = "mbox";
	if(hostname == NULLCHAR) {
		fprintf(stderr,"%s: hostname not set\r\n",runcom);
		exit(1);
	}
	if(username == NULLCHAR) {
		fprintf(stderr,"%s: username not set\n",runcom);
		exit(1);
	}
}

/* return the line_type from a line of the configuration file */
rc_line_type(s)
register char *s;
{
	register struct token *tp;
	for (tp = rccmds; tp->str != NULLCHAR; tp++) {
		if (strncmp(tp->str,s,strlen(tp->str)) == 0)
			return tp->type;
	}
	return (NONE);
}

/* replace terminating end of line marker(s) with null */
rip(s)
register char *s;
{
	for (; *s; s++)
		if (*s == '\r' || *s == '\n') {
			*s = '\0';
			break;
		}
}

/* copy a string return a pointer to it */
char *
savestr(s)
char *s;
{
	register  char *p;
	p = malloc(strlen(s)+1);
	if (p == NULLCHAR) 
		printf("No more memory\n");
	else
		strcpy(p,s);
	return p;
}

dohelp(int s)
{
	xprint_header(s,"Main Menu Selection");
	xprintf(s,"<UL>");
	xprintf(s,"<LI><A HREF=\"n\">Message subject selection list.</A></LI>");
	xprintf(s,"<LI><A HREF=\"m\">List messges in send queue.</A></LI>");

	xprintf(s,"</UL>");
	xprint_footer(s);
}



bmexit(new_s,x)
int new_s;
int x;
{
	if(!fflag && lockit(new_s))
		exit(1);
	if (mfile != NULLFILE)
		 fclose(mfile);
	if (!fflag)
		rmlock(maildir,notename);
	exit(x);
}

/* this is the main command processing loop */
getcommand(int new_s)
{
	FILE *tfile, *tmpfile();
	int fp;
	char	command[LINELEN];	/* command lin e      */
	char  argument[LINELEN];  /*  COMMAND LINE */
	char	*args[MAXARGS];
	int	nargs;
	char	*cp;
	register int	msgnum;
	register int	i;
	int counter,j;
	int ret;
	char * temp;
	char * input_line;
	extern int MAIL_READWRITE;
		 /* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }



	/***************** command parsing loop *****************/
	while(xgets(new_s,command) != -1) {

	 /* Eliminate the carriage returns and line feeds */
	 for (i=0;i<strlen(command);i++)
	 {
	  switch (command[i])
	  {
	  case '\n':
	  case '\r': command[i] = ' ';
	  }
	 }

	  /* Make sure this is a GET command */
	  if (sscanf(command,"GET /%s HTTP/1.0",argument)<1)
	  {
		printf("Invalid command [%s]\n",command);
		free(temp);
		return 0;
	  };

		/* Parse the arguments */
		if (*argument) {
			cp = argument;
		/*	while (*cp && *cp != ' ')
				cp++;   */
			nargs = parse(cp,args,MAXARGS);
		}
		printf("n=%d 0:[%s] 1:[%s] 2:[%s] 3:[%s]  4:[%s]\n",nargs,
		  args[0], args[1], args[2], args[3], args[4]);



		/*  Handle the single character special character */
		if (strlen(args[0]) == 1)
		{                             /* do this switch for a single character */
		switch (*args[0]) {

		case 'm':		/* display unsent messages */
			listqueue(new_s);
			free(temp);
			return(0);
			break;

		case 'n': 	/* display or change notefiles */
		 /*  printf("mboxnames\n");    */
			mboxnames(new_s,nargs,args);
			if (nargs == 2) listnotes(new_s);
			free(temp);
			return(0);
			break;

		case 'r':
			if(nargs < 1)
			{
				free(temp);
				return(0);
				break;
			 }
			else
			 {
				mboxnames(new_s,nargs,args);
				msgnum = atoi(args[2]);
			 }
			if (msgnum < 0 || msgnum > nmsgs)
			{
				sprintf(temp,badmsg,msgnum);
				xprintf(new_s,temp);
			}
			else
			{
				 current = msgnum;    printf("Current msg=%d\n",current);
				 displaymsg(new_s,current);
			}
			free(temp);
			return(0);
			break;


		case 'l':		/* list message headers in notesfile */
			listnotes(new_s);
			free(temp);
			return(0);
			break;


		default:
			dohelp(new_s);
			free(temp);
			return(0);;
			break;
		}  /* end switch */
		} /* this ends the test for a single character */
		else
		{  /* begin the test for other stuff */

		 /* send the binary file */
		  if ((nargs == 1) && ((strstr(args[0],".gif") != NULL) ||
										(strstr(args[0],".jpg") != NULL)))
		  {
			 sprintf(temp,"l:\\gopher\\%s",args[0]);
			 send_file(new_s,temp,TRUE);
			 free(temp);
			 return 0;
		  }



		  /* send an htm file  or txt file  (not all files end in .xxx) */
		  if ((nargs == 1) /* && ((strstr(args[1],".htm") != NULL) ||
					 (strstr(args[1],".txt") != NULL))*/  )
		  {
			 sprintf(temp,"l:\\gopher\\%s",args[0]);
			 send_file(new_s,temp,TRUE);
			 free(temp);
			 return 0;
			}


 /* Handle the search function */
 /* The file to be searched is to be called file.txt */
 /* ISINDEX Command */
 if ((nargs == 2)&& (strstr(args[0],".htm") != NULL))
 {
	 if ((input_line = (char *) malloc(255)) == NULL)
	 {
		 printf("Not enough memory to allocate input_linebuffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }
  cp = strrchr(args[0],'.');
  *cp = '\0';
  strcat(args[0],".txt");
  sprintf(temp,"l:\\gopher\\%s",args[0]);
  counter = 0;
  /* printf("ISINDEX file=[%s] search=[%s]\n",file, search);*/
	if ((fp = fopen(temp,"r")) != NULLFILE)
	{
	 xprint_header(new_s,"Search Results");
	 xprintf(new_s,"<PRE>");
	 input_line[0] = 0;
	 do
	 {
		 if(strstr(input_line,args[1]) != NULLCHAR)
		 {
			sprintf(temp,"%3i : %s",++counter, input_line);
			xprintf(new_s,temp);
		 }
		if (counter > 50) break;
	  } while (fgets(input_line,250,fp) != NULL);

	 if (counter > 50)
	 {
		xprintf(new_s,"\nTotal matches > 50, search terminated....\n");
		xprintf(new_s,"Please try again with new sort parameter..\n");
	 }
	 else
	 {
		sprintf(temp,"\nTotal %i matches...\n</PRE>",counter);
		xprintf(new_s,temp);
	 }
	 xprint_footer(new_s);
	 fclose(fp);
	}
	else
	{
	  badopen(new_s, args[0]);
	}
  free(temp);
  free(input_line);
  return 0;
 }


			/* send the default welcome file  */
			if ((nargs < 2))
			{
			  send_file(new_s,"l:\\gopher\\welcome.htm",TRUE);
			  free(temp);
			  return 0;
			}


		 printf("Missed everything %s...\n", args[1]);
		 free(temp);
		 return 0;
		}     /* end of the if character or string test */

	}  /* end of while */
	free(temp);
	return 0;
}

/* list or change mbox */
mboxnames(new_s,argc,argv)
int argc;
char *argv[];
int new_s;
{
	register char *cp;
	int ret;
	char	line[80];
	char	buf[LINELEN];
	char * temp;
	extern char aa6ed[];
	int count;

	 /* allocate memory for string */
	 if ((temp = (char *) malloc(300)) == NULL)
	 {
		 printf("Not enough memory to allocate buffer\n");
		 exit(1);  /* terminate program if out of memory */
	 }

	if(argc > 1) {
		if(!fflag && lockit(new_s))
		{
			free(temp);
			return;
		 }
		if (mfile != NULLFILE)
			fclose(mfile);
		if (!fflag)
			rmlock(maildir,notename);
			if (strpbrk(argv[1],"/\\") != NULLCHAR) {
				fflag = 1;
				mfilename = argv[1];
			} else {
				fflag = 0;
				mfilename = notefile;
				strncpy(notename,argv[1],8);
				notename[8] = '\0';
				cp = strrchr(notename,'.');
				if (cp != NULL)
							*cp = '\0';
				if (strlen(notename) == 0)
				{
				 xprintf(new_s,"Error : Invalid input..\n");
				 free(temp);
				 return;
				}
				sprintf(notefile,"%s/%s.txt",maildir,notename);
				printf("Notefile: %s\n",notefile);
			}
			if (!fflag && lockit(new_s)) {
				mfile = NULLFILE;
			  /* 	xprintf(new_s,"</UL>");  */
				xprintf(new_s,"<H3>Mail file is busy</H3>");
				xprint_footer(new_s);
				free(temp);
				return;
			}
			ret = initnotes(new_s);
			if (!fflag)
				rmlock(maildir,notename);
			if (ret != 0)
				exit(1);
		 /*	listnotes(new_s);   */

		} else {  /* he wants to see what notefiles there are */
		xprint_header(new_s,"Please select from the following areas:<BR>");
		  xprintf(new_s,"<PRE>");
			count = 0;
			sprintf(buf,"%s/*.txt",maildir,notename);
			filedir(buf,0,line);
			while(line[0] != '\0') {
				cp = strchr(line,'.');
				*cp = '\0';
				if (isdigit(line[1]) || isdigit(line[2]))
				{/* do nothing */}
				else
				{
				  sprintf(temp,"<A HREF=\"%sn+%s\">%8s</A>\t",aa6ed,line,line);
				  xprintf(new_s,temp);
				  count++;
				  if (count > 5)
				  {
					count = 0;
					xprintf(new_s,"\n");
				  }
				 }
				filedir(buf,1,line);
			}
		xprintf(new_s,"\n</PRE>");
		xprint_footer(new_s);
		}
		free(temp);
}

reinit(new_s)
{
	int ret;
	if (!fflag && lockit(new_s))
		return;
	if (mfile != NULLFILE)
			fclose(mfile);
	if (!fflag)
		rmlock(maildir,notename);
	if (!fflag && lockit(new_s)) {
		mfile = NULLFILE;
		xprintf(new_s,"Mail file is busy\r\n");
		return;
	}
	ret = initnotes(new_s);
	if (!fflag)
		rmlock(maildir,notename);
	if (ret != 0)
		exit(1);
	listnotes(new_s);
}
